// C Source File
// Created 6/7/2004; 7:39:16 PM

#ifndef _EXPLOSION_C_
#define _EXPLOSION_C_

#include "explosion.h"

void makeFloorExplosion(Explosion *this, short radius)
{
	this->time = 10;

	Point defaultPoint = newPoint(radius, 0, 0);

	this->addTo0 = newPoint(0,  -3, 0);
	this->addTo1 = newPoint(0,  -1, 0);

	this->rotation = newAngle(0, 0, 0);


	this->location.y = 0;

	int i;
	for (i=0; i<16; i++) {
		Point newp = rotatePoint(defaultPoint, newAngle(0, 16*i, 0));
		this->shrapnel[i].point[0] = newPoint(newp.x, 0, newp.z);
		this->shrapnel[i].point[1] = newPoint(newp.x, -(random(10)+15), newp.z);
	}

}

void makeCircleExplosion(Explosion *this, short radius)
{
	this->time = 10;

	this->addTo0 = newPoint(0,  0, 0);
	this->addTo1 = newPoint(0,  0, 0);

	this->rotation = newAngle(0, 4, 0);

	int i;
	Point newp0, newp1;
	for (i=0; i<16; i++) {
		newp0 = rotatePoint(newPoint(0, 0, radius), newAngle(0, 16*i, 0));
		newp1 = rotatePoint(newPoint(0, 0, radius+random(10)), newAngle(0, 16*i, 0));
		this->shrapnel[i].point[0] = newp0;
		this->shrapnel[i].point[1] = newp1;
	}

}

void doExplosionStuff(Camera *camera, Explosion *this)
{
	drawLines(camera, this->location, newAngle(this->rotation.x*this->time, this->rotation.y*this->time, this->rotation.z*this->time), this->shrapnel, 16, 1);
	this->time--;

	int i;
	for (i=0; i<16; i++) {
		this->shrapnel[i].point[0].x += this->addTo0.x;
		this->shrapnel[i].point[0].y += this->addTo0.y;
		this->shrapnel[i].point[0].z += this->addTo0.z;
		this->shrapnel[i].point[1].x += this->addTo1.x;
		this->shrapnel[i].point[1].y += this->addTo1.y;
		this->shrapnel[i].point[1].z += this->addTo1.z;
	}
}

#endif
