// Header File
// Created 3/22/2004; 5:13:54 PM

#ifndef _GRAPHICS_H_
#define _GRAPHICS_H_

#include <tigcclib.h>
#include "extgraph.h"

#define USEGRAYSCALE 0

typedef struct {
	int x,		//length
		y,		//width
		z;		//height
} Point;

typedef struct {

	Point point[2];

} Line;

typedef struct {
	unsigned char x, y, z;
} Angle;

typedef struct {
	int x, y;
	char drawMe;
} ScreenPoint;

typedef struct {

	Point center;
	Angle angle;
	int distortion;

} Camera;

void drawShape(const Camera *camera, Point offset, Point *point, int numPoints);
void drawLines(const Camera *camera, Point offset, Angle rotation, Line *line, int numLines, char color);
void drawLinesFast(const Camera *camera, Point offset, Line *line, int numLines, char color);

int getLookupCos(unsigned char angle);
int getLookupSin(unsigned char angle);

Point newPoint(int x, int y, int z);
Angle newAngle(unsigned char x, unsigned char y, unsigned char z);

Point rotatePoint(Point original, Angle rotation);

void FastDrawLineClip(unsigned char* plane, short x1,short y1, short x2,short y2);

#endif